#-----------------------------------------------------------
#
# Persona Programming - ͳʹʬ
#
#-----------------------------------------------------------

# ----- update
#
# Nov.23.2005 - rerofumi <rero2@yuumu.org>
#     Level1 ޤǺλ
#

require 'stack_lang.rb'


#--------------------------------------------
#  Level0 : 
#--------------------------------------------
# ͳʤޤʤƥ।󥿡եʬ
class  PersonaBase

  def initialize
    @logic = StackLangLv3::new
  end

  def action(command, item)
    # virtual
  end

  def talk
    speak = @logic.get_console
    @logic.clear_console
    speak
  end

  def remember(stack)
    @logic.unpack_stack(stack)
  end

  def memory
    @logic.pack_stack
  end

end



#--------------------------------------------
#  Level1 :  Ϸ׻Ǥޤ
#--------------------------------------------
# ̿Υץ
class  PersonaLangUikaLv1 < PersonaBase

  # -- ޥɤȥ᥽åɤδϢŤ
  Command = {
    "uika_enter"=>"ac_enter",
    "uika_display"=>"ac_display",
    "uika_dup"=>"ac_dup",
    "uika_drop"=>"ac_drop",
    "uika_swap"=>"ac_swap",
    "uika_clear"=>"ac_clear",
    "uika_add"=>"ac_add",
    "uika_sub"=>"ac_sub",
    "uika_mul"=>"ac_mul",
    "uika_div"=>"ac_div",
    "uika_mod"=>"ac_mod",
    "uika_rnd"=>"ac_rnd",
    "uika_test_equal"=>"ac_test_equal",
    "uika_test_not_equal"=>"ac_test_not_equal",
    "uika_test_less"=>"ac_test_less",
    "uika_test_great"=>"ac_test_great",
    "uika_if"=>"ac_if",
    "uika_else"=>"ac_else",
    "uika_endif"=>"ac_endif",
  }

  def initialize
    super
    @arg = ""
  end

  def action(command, item)
    @arg = item
    if Command.include?(command) == true then
      send(Command[command])
    elsif (command == "") && (item == "") then
      ac_initialize
    end
  end



 :private

  def error_message(reason)
    message = ""
    case(reason)
      when StackLangLv1::ERROR_STACK_EMPTY
        message << '"ꤿɤ⡢­ʤΡ" .'
      when StackLangLv1::ERROR_STACK_NOT_ENOUGH
        message << '"äȤƤʤȤǤʤ褥" .'
      when StackLangLv1::ERROR_WRONG_ITEM
        message << '"졩뤤Ǥʤä衣" .'
      when StackLangLv1::ERROR_OVER_RESOURCE
        message << '"ʤˤäѤ褦" .'
      when StackLangLv1::ERROR_UNKNOWN_WORD
        message << '"θդ狼ʤΤǤǤޤ" .'
      when StackLangLv1::ERROR_ZERO_DEVIDE
        message << '"Τ͡ǳä餤ʤ衣ΤäƤ" .'
      when StackLangLv1::ERROR_NOT_MATCH_NEST
        message << '"졢ɤθդĤʤ衣" .'
      when StackLangLv1::ERROR_WORD_CONFLICT
        message << '"θդϤ⤦ΤäƤ뤫٤Ĥ̾ˤ褦衣" .'
      when StackLangLv1::ERROR_WORD_WRONG
        message << '"θդϻȤä㤤ʤ衣" .'
      else
        message << '"褯狼ʤɤǤʤä衣" .'
    end
    message
  end

  def ac_initialize
    talk = ""
    talk << '3 rand '
    talk << 'dup 0 == if "ƤĤ͡" swap endif '
    talk << 'dup 1 == if "ϤȤɤʤä򤹤Ρ" swap endif '
    talk << 'dup 2 == if "Ϥ꤭ä㤦͡" swap endif '
    talk << 'drop .'
    @logic.exec_stack_line(talk)
  end

  def ac_enter
    talk = ""
    # - types
    unless @arg =~ /^[\-0-9.]+$/ then
      @arg = '"' + @arg + '"'
    end
    # - feedback
    if (@arg =~ /^"\s+"$/) || (@arg == '""') then
      talk << '3 rand '
      talk << 'dup 0 == if "ʤˤƤʤ㤪ܤʤ褥" swap endif '
      talk << 'dup 1 == if "狼ʤ" swap endif '
      talk << 'dup 2 == if "ʤˤ򤪤ܤɤΡ" swap endif '
      talk << 'drop .'
    elsif (@arg =~ /\s/) then
      talk << '"ʤΤ͡ڡȤ֤ȤäޤʤΡġġ" .'
    elsif @logic.command?(@arg) then
      talk << '2 rand '
      talk << 'dup 0 == if "θդäƤ롼áθդˤϰ̣뤫ȻȤäƤ͡" else '
      talk << '"Ĥä㤤ʤñ줬ޤäƤ衩" endif '
      talk << '. drop'
    else
      if @logic.exec_word(@arg) == StackLangLv1::DONE then
        talk << '3 rand '
        talk << 'dup 0 == if "󡢤狼ä" swap endif '
        talk << 'dup 1 == if "դˤ" swap endif '
        talk << 'dup 2 == if "Ĥϡ" swap endif '
        talk << 'drop .'
      else
        talk << '"줧ʤ󤫤衩" '
        talk << '.'
      end
    end
    @logic.exec_stack_line(talk)
  end

  def ac_display
    talk = ""
    result = @logic.exec_word('.')
    if result == StackLangLv1::DONE then
      answer = @logic.get_console
      unless answer =~ /^[\-0-9.]+$/ then
        answer = '"' + answer + '"'
      end
      @logic.clear_console
      talk << '2 rand '
      talk << 'dup 0 == if "Τ͡" swap endif '
      talk << 'dup 1 == if "ȡ" swap endif '
      talk << 'drop . '
      talk << answer
      talk << ' . '
      talk << '3 rand '
      talk << 'dup 0 == if "衣" swap endif '
      talk << 'dup 1 == if "ǤΤʤ" swap endif '
      talk << 'dup 2 == if "" swap endif '
      talk << 'drop .'
    elsif result == StackLangLv1::STACK_WORK then
      talk << '3 rand '
      talk << 'dup 0 == if "դդࡣ" swap endif '
      talk << 'dup 1 == if "󤦤" swap endif '
      talk << 'dup 2 == if "" swap endif '
      talk << 'drop . '
    else
      talk << error_message(result)
    end
    @logic.exec_stack_line(talk)
  end

  def ac_dup
    talk = ""
    result = @logic.exec_word('dup')
    if result == StackLangLv1::DONE then
      talk << '2 rand '
      talk << 'dup 0 == if "ƱΤ⤦ҤȤѰդ衣" swap endif '
      talk << 'dup 1 == if "դ㤤ޤˤˤ" swap endif '
      talk << 'drop . '
    elsif result == StackLangLv1::STACK_WORK then
      talk << '3 rand '
      talk << 'dup 0 == if "դդࡣ" swap endif '
      talk << 'dup 1 == if "󤦤" swap endif '
      talk << 'dup 2 == if "" swap endif '
      talk << 'drop . '
    else
      talk << error_message(result)
    end
    @logic.exec_stack_line(talk)
  end

  def ac_drop
    talk = ""
    result = @logic.exec_word('drop')
    if result == StackLangLv1::DONE then
      talk << '3 rand '
      talk << 'dup 0 == if "ݤ" swap endif '
      talk << 'dup 1 == if "ʡ" swap endif '
      talk << 'dup 2 == if "Ƥä衢⤦ȤʤΤʤ" swap endif '
      talk << 'drop . '
    elsif result == StackLangLv1::STACK_WORK then
      talk << '3 rand '
      talk << 'dup 0 == if "դդࡣ" swap endif '
      talk << 'dup 1 == if "󤦤" swap endif '
      talk << 'dup 2 == if "" swap endif '
      talk << 'drop . '
    else
      talk << error_message(result)
    end
    @logic.exec_stack_line(talk)
  end

  def ac_swap
    talk = ""
    result = @logic.exec_word('swap')
    if result == StackLangLv1::DONE then
      talk << '3 rand '
      talk << 'dup 0 == if "褤äȡ줫ޤ" swap endif '
      talk << 'dup 1 == if "äΤ˻äƤ衣" swap endif '
      talk << 'dup 2 == if "Ƥơ줫äƤäȡ" swap endif '
      talk << 'drop . '
    elsif result == StackLangLv1::STACK_WORK then
      talk << '3 rand '
      talk << 'dup 0 == if "դդࡣ" swap endif '
      talk << 'dup 1 == if "󤦤" swap endif '
      talk << 'dup 2 == if "" swap endif '
      talk << 'drop . '
    else
      talk << error_message(result)
    end
    @logic.exec_stack_line(talk)
  end

  def ac_clear
    talk = ""
    result = @logic.exec_word('clear')
    if result == StackLangLv1::DONE then
      talk << '3 rand '
      talk << 'dup 0 == if "ϤɤʤϤʤƤΡ" swap endif '
      talk << 'dup 1 == if "äȤϤʤ褦衣" swap endif '
      talk << 'dup 2 == if "äꥭ쥤ˤʤޤ" swap endif '
      talk << 'drop . '
    elsif result == StackLangLv1::STACK_WORK then
      talk << '3 rand '
      talk << 'dup 0 == if "դդࡣ" swap endif '
      talk << 'dup 1 == if "󤦤" swap endif '
      talk << 'dup 2 == if "" swap endif '
      talk << 'drop . '
    else
      talk << error_message(result)
    end
    @logic.exec_stack_line(talk)
  end

  def ac_add
    talk = ""
    result = @logic.exec_word('+')
    if result == StackLangLv1::DONE then
      talk << 'dup dup 0 < if -1 * endif '
      talk << '"衣" swap '
      talk << 'dup 100000 > if swap drop "ࡣ" swap endif '
      talk << 'dup 10000000 > if swap drop "ࡣǤ衣" swap endif '
      talk << 'drop . '
    elsif result == StackLangLv1::STACK_WORK then
      talk << '3 rand '
      talk << 'dup 0 == if "դդࡣ" swap endif '
      talk << 'dup 1 == if "󤦤" swap endif '
      talk << 'dup 2 == if "" swap endif '
      talk << 'drop . '
    else
      talk << error_message(result)
    end
    @logic.exec_stack_line(talk)
  end

  def ac_sub
    talk = ""
    result = @logic.exec_word('-')
    if result == StackLangLv1::DONE then
      talk << 'dup dup 0 < if -1 * endif '
      talk << '"ҤǤ衣" swap '
      talk << 'dup 100000 > if swap drop "ȡ󡢤褷" swap endif '
      talk << 'dup 10000000 > if swap drop "ȡҤ衣" swap endif '
      talk << 'drop . '
    elsif result == StackLangLv1::STACK_WORK then
      talk << '3 rand '
      talk << 'dup 0 == if "դդࡣ" swap endif '
      talk << 'dup 1 == if "󤦤" swap endif '
      talk << 'dup 2 == if "" swap endif '
      talk << 'drop . '
    else
      talk << error_message(result)
    end
    @logic.exec_stack_line(talk)
  end

  def ac_mul
    talk = ""
    result = @logic.exec_word('*')
    if result == StackLangLv1::DONE then
      talk << 'dup dup 0 < if -1 * endif '
      talk << '"󤷤衣" swap '
      talk << 'dup 100000 > if swap drop "դࡣʤΤʡ" swap endif '
      talk << 'dup 10000000 > if swap drop "դդࡣ׻Ǥ衣" swap endif '
      talk << 'drop . '
    elsif result == StackLangLv1::STACK_WORK then
      talk << '3 rand '
      talk << 'dup 0 == if "դդࡣ" swap endif '
      talk << 'dup 1 == if "󤦤" swap endif '
      talk << 'dup 2 == if "" swap endif '
      talk << 'drop . '
    else
      talk << error_message(result)
    end
    @logic.exec_stack_line(talk)
  end

  def ac_div
    talk = ""
    result = @logic.exec_word('/')
    if result == StackLangLv1::DONE then
      talk << '3 rand '
      talk << 'dup 0 == if "äƤȤ⤦衣" swap endif '
      talk << 'dup 1 == if "ꤶ󡢤塼硼" swap endif '
      talk << 'dup 2 == if "ϤȤʤá" swap endif '
      talk << 'drop . '
    elsif result == StackLangLv1::STACK_WORK then
      talk << '3 rand '
      talk << 'dup 0 == if "դդࡣ" swap endif '
      talk << 'dup 1 == if "󤦤" swap endif '
      talk << 'dup 2 == if "" swap endif '
      talk << 'drop . '
    else
      talk << error_message(result)
    end
    @logic.exec_stack_line(talk)
  end

  def ac_mod
    talk = ""
    result = @logic.exec_word('%')
    if result == StackLangLv1::DONE then
      talk << '3 rand '
      talk << 'dup 0 == if "ޤޤ" swap endif '
      talk << 'dup 1 == if "äѤġʤ衣" swap endif '
      talk << 'dup 2 == if "ꤶΤޤꤵá" swap endif '
      talk << 'drop . '
    elsif result == StackLangLv1::STACK_WORK then
      talk << '3 rand '
      talk << 'dup 0 == if "դդࡣ" swap endif '
      talk << 'dup 1 == if "󤦤" swap endif '
      talk << 'dup 2 == if "" swap endif '
      talk << 'drop . '
    else
      talk << error_message(result)
    end
    @logic.exec_stack_line(talk)
  end

  def ac_rnd
    talk = ""
    result = @logic.exec_word('rand')
    if result == StackLangLv1::DONE then
      talk << '2 rand '
      talk << 'dup 0 == if "󡢤ҤȤĤ衣" swap endif '
      talk << 'dup 1 == if "ʤǤ褫ä͡" swap endif '
      talk << 'drop . '
    else
      talk << error_message(result)
      talk << ' "ʿȤäƤϤ󤤤餤Ƥ褥" .'
    end
    @logic.exec_stack_line(talk)
  end

  def ac_test_equal
    talk = ""
    result = @logic.exec_word('==')
    if result == StackLangLv1::DONE then
      talk << '2 rand '
      talk << 'dup 0 == if "ƱɤĴ٤ɤ͡" swap endif '
      talk << 'dup 1 == if "ȤΤҤȤ٤ȡġġ" swap endif '
      talk << 'drop . '
    elsif result == StackLangLv1::STACK_WORK then
      talk << '3 rand '
      talk << 'dup 0 == if "դդࡣ" swap endif '
      talk << 'dup 1 == if "󤦤" swap endif '
      talk << 'dup 2 == if "" swap endif '
      talk << 'drop . '
    else
      talk << error_message(result)
    end
    @logic.exec_stack_line(talk)
  end

  def ac_test_not_equal
    talk = ""
    result = @logic.exec_word('!=')
    if result == StackLangLv1::DONE then
      talk << '2 rand '
      talk << 'dup 0 == if "ɤĴ٤ޤ" swap endif '
      talk << 'dup 1 == if "٤Ƥߤ衣" swap endif '
      talk << 'drop . '
    elsif result == StackLangLv1::STACK_WORK then
      talk << '3 rand '
      talk << 'dup 0 == if "դդࡣ" swap endif '
      talk << 'dup 1 == if "󤦤" swap endif '
      talk << 'dup 2 == if "" swap endif '
      talk << 'drop . '
    else
      talk << error_message(result)
    end
    @logic.exec_stack_line(talk)
  end

  def ac_test_less
    talk = ""
    result = @logic.exec_word('>')
    if result == StackLangLv1::DONE then
      talk << '2 rand '
      talk << 'dup 0 == if "ɤä" swap endif '
      talk << 'dup 1 == if "٤ä衣" swap endif '
      talk << 'drop . '
    elsif result == StackLangLv1::STACK_WORK then
      talk << '3 rand '
      talk << 'dup 0 == if "դդࡣ" swap endif '
      talk << 'dup 1 == if "󤦤" swap endif '
      talk << 'dup 2 == if "" swap endif '
      talk << 'drop . '
    else
      talk << error_message(result)
    end
    @logic.exec_stack_line(talk)
  end

  def ac_test_great
    talk = ""
    result = @logic.exec_word('<')
    if result == StackLangLv1::DONE then
      talk << '2 rand '
      talk << 'dup 0 == if "ɤä" swap endif '
      talk << 'dup 1 == if "٤ä衣" swap endif '
      talk << 'drop . '
    elsif result == StackLangLv1::STACK_WORK then
      talk << '3 rand '
      talk << 'dup 0 == if "դդࡣ" swap endif '
      talk << 'dup 1 == if "󤦤" swap endif '
      talk << 'dup 2 == if "" swap endif '
      talk << 'drop . '
    else
      talk << error_message(result)
    end
    @logic.exec_stack_line(talk)
  end

  def ac_if
    talk = ""
    result = @logic.exec_word('if')
    if result == StackLangLv1::DONE then
      talk << '2 rand '
      talk << 'dup 0 == if "⤷äʤˤ򤹤ɤΤʡ" swap endif '
      talk << 'dup 1 == if "ä顢뤳Ȥ򤪤Ƥ͡" swap endif '
      talk << 'drop . '
    else
      talk << error_message(result)
    end
    @logic.exec_stack_line(talk)
  end

  def ac_else
    talk = ""
    result = @logic.exec_word('else')
    if result == StackLangLv1::DONE then
      talk << '2 rand '
      talk << 'dup 0 == if "ȤʤˤΡ" swap endif '
      talk << 'dup 1 == if "ǤʤȤ뤳Ȥ򤪤Ƥ͡" swap endif '
      talk << 'drop . '
    else
      talk << error_message(result)
    end
    @logic.exec_stack_line(talk)
  end

  def ac_endif
    talk = ""
    result = @logic.exec_word('endif')
    if result == StackLangLv1::DONE then
      talk << '2 rand '
      talk << 'dup 0 == if "ϤޤǤ͡" swap endif '
      talk << 'dup 1 == if "줿Ȥˤá" swap endif '
      talk << 'drop . '
    else
      talk << error_message(result)
    end
    @logic.exec_stack_line(talk)
  end


end

