#-----------------------------------------------------------
#
# Forth äݤå١ for Persona Programming
#
#-----------------------------------------------------------

# ----- update
#
# Nov.22.2005 - rerofumi <rero2@yuumu.org>
#     Level1 ޤǺλunpack_stack()ײ
#



#--------------------------------------------
#  Level0 : åȥȥߥå
#--------------------------------------------
# Lv0 Υ󥹥󥹰ĤåǤꡢ桼ɤǤ
# ѿɤμΤǤȤäȤꤷƤ
# 1󥹥󥹤 1ѿȤΤϼ㴳Ĺ
class  StackLangLv0

  def initialize
    @stack = Array::new
    @variable = nil
    @word = ''
    @type = 0
  end


  # --- error retern value
  # ̵λȤ
  DONE = 0
  # if ǥåѤΤȤ
  STACK_WORK = 1
  # åäݤǤ
  ERROR_STACK_EMPTY = 2
  # ׵᤹륹åο­ޤ
  ERROR_STACK_NOT_ENOUGH = 3
  # ׵᤹륹åη㤤ޤ
  ERROR_WRONG_ITEM = 4
  # ѥ꥽򥪡Сޤ
  ERROR_OVER_RESOURCE = 5
  # ʥɤǤ
  ERROR_UNKNOWN_WORD = 6
  # 0ǽ褦Ȥޤ
  ERROR_ZERO_DEVIDE = 7
  # бɤĤޤ
  ERROR_NOT_MATCH_NEST = 8
  # ѤƤɤǤ
  ERROR_WORD_CONFLICT = 9
  # ʥɤǤ
  ERROR_WORD_WRONG = 10

  attr_reader :DONE
  attr_reader :ERROR_STACK_EMPTY
  attr_reader :ERROR_STACK_NOT_ENOUGH
  attr_reader :ERROR_WRONG_ITEM
  attr_reader :ERROR_OVER_RESOURCE
  attr_reader :ERROR_UNKNOWN_WORD
  attr_reader :ERROR_ZERO_DEVIDE
  attr_reader :ERROR_NOT_MATCH_NEST
  attr_reader :ERROR_WORD_CONFLICT 

  def clear_stack
    @stack.clear
  end

  def push_stack(item)
    @stack.push(item)
  end

  def pop_stack
    @stack.pop
  end

  def fifo_stack
    item = @stack.first
    @stack.delete_at(0)
    item
  end

  def push_value(item)
    if item =~ /^[\-0-9.]+$/ then
      if item =~ /\./ then
        push_stack(item.to_f)
      else
        push_stack(item.to_i)
      end
      DONE
    else
      push_stack(item)
      DONE
    end
  end

  def stack_size
    @stack.size
  end

  def your_word?(name)
    if @word == name then
      result = true
    else
      result = false
    end
    result
  end

  def set_word(name)
    @word = String::new(name)
  end

  def pack_stack
    @stack.join(' ')
  end

  def unpack_stack(archive)
    @stack.clear
    @stack = archive.split("\s")
  end

  def set_value(item)
    @valiable = item
  end

  def get_value
    @valiable
  end

end



#--------------------------------------------
#  Level1 : ץߥƥ֥ޥɤμ
#--------------------------------------------
class  StackLangLv1 < StackLangLv0

  # - internal command
  InternalWord = {
    'clear' => "do_clear",
    '.' => "do_dot",
    'dup' => "do_dup",
    'drop' => "do_drop",
    'swap' => "do_swap",
    '+' => "do_add",
    '-' => "do_sub",
    '*' => "do_mul",
    '/' => "do_div",
    '%' => "do_mod",
    'rand' => "do_rand",
    'true' => "do_true",
    'false' => "do_false",
    '==' => "do_equal",
    '!=' => "do_not_equal",
    '<' => "do_less",
    '>' => "do_great", 
    'if' => "do_if",
    'else' => "do_else",
    'endif' => "do_endif"
  }

  # -- if nesting work
  IfWorkSyntax = [
    "if",
    "else",
    "endif"
  ]

  def initialize
    super
    @console = ''
    @if_nest_count = 0
    srand
  end

  def clear_stack
    super
    @if_nest_count = 0
  end

  def clear_console
    @console = ''
  end

  def get_console
    @console
  end


  def command?(item)
    InternalWord.key?(item)
  end

  def command(item)
    method = InternalWord[item]
    if respond_to?(method) == true then
      send(method)
    end
  end

  def push_value(item)
    if command?(item) then
      push_stack(item)
      DONE
    else
      super
    end
  end

  def unpack_stack(archive)
    clear_stack
    # === ԴʤΤǸľ
    list = archive.split("\s")
    list.each do |item|
      push_value(item)
      if (item == IfWorkSyntax[0]) then
        @if_nest_count += 1;
      end
      if (item == IfWorkSyntax[2]) then
        @if_nest_count -= 1;
      end
    end
  end

  def exec_word(item)
    if command?(item) then
      if (@if_nest_count == 0) ||
         (IfWorkSyntax.member?(item) == true) then
        command(item)
      else
        push_stack(item)
        STACK_WORK
      end
    else
      push_value(item)
    end
  end

  def exec_stack_line(line)
    ifcnt = @if_nest_count
    @if_nest_count = 0
    cmd = StackLangLv0::new
    cmd.unpack_stack(line)
    while cmd.stack_size > 0 do
      item = cmd.fifo_stack
      result = exec_word(item)
      if (result != DONE) && (result != STACK_WORK) then
        break
      end
    end
    @if_nest_count = ifcnt
  end


 :private

  def do_clear
    clear_stack
    DONE
  end

  def do_dot
    if (stack_size > 0) then
      item = pop_stack.to_s
      if item =~ /"(.*)"/ then
        @console << $1
      else
        @console << item
      end
      DONE
    else
      ERROR_STACK_EMPTY
    end
  end

  def do_dup
    if (stack_size > 0) then
      item = pop_stack
      push_stack(item)
      push_stack(item)
      DONE
    else
      ERROR_STACK_EMPTY
    end
  end

  def do_drop
    if (stack_size > 0) then
      pop_stack
      DONE
    else
      ERROR_STACK_EMPTY
    end
  end

  def do_swap
    if (stack_size >= 2) then
      item1 = pop_stack
      item2 = pop_stack
      push_stack(item1)
      push_stack(item2)
      DONE
    else
      ERROR_STACK_NOT_ENOUGH
    end
  end

  def do_add
    if (stack_size >= 2) then
      item1 = pop_stack
      item2 = pop_stack
      if (item1.class != String) && (item2.class != String) then
        answer = item1 + item2
        push_stack(answer)
        DONE
      else
        push_stack(item2)
        push_stack(item1)
        ERROR_WRONG_ITEM
      end
    else
      ERROR_STACK_NOT_ENOUGH
    end
  end

  def do_sub
    if (stack_size >= 2) then
      item1 = pop_stack
      item2 = pop_stack
      if (item1.class != String) && (item2.class != String) then
        answer = item2 - item1
        push_stack(answer)
        DONE
      else
        push_stack(item2)
        push_stack(item1)
        ERROR_WRONG_ITEM
      end
    else
      ERROR_STACK_NOT_ENOUGH
    end
  end

  def do_mul
    if (stack_size >= 2) then
      item1 = pop_stack
      item2 = pop_stack
      if (item1.class != String) && (item2.class != String) then
        answer = item1 * item2
        push_stack(answer)
        DONE
      else
        push_stack(item2)
        push_stack(item1)
        ERROR_WRONG_ITEM
      end
    else
      ERROR_STACK_NOT_ENOUGH
    end
  end

  def do_div
    if (stack_size >= 2) then
      item1 = pop_stack
      item2 = pop_stack
      if (item1.class != String) && (item2.class != String) then
        if (item1 == 0) then
          push_stack(item2)
          push_stack(item1)
          ERROR_ZERO_DEVIDE
        elsif ((item2 % item1) == 0) then
          answer = item2 / item1
          push_stack(answer)
          DONE
        else
          answer = item2.to_f / item1.to_f
          push_stack(answer)
          DONE
        end
      else
        push_stack(item2)
        push_stack(item1)
        ERROR_WRONG_ITEM
      end
    else
      ERROR_STACK_NOT_ENOUGH
    end
  end

  def do_mod
    if (stack_size >= 2) then
      item1 = pop_stack
      item2 = pop_stack
      if (item1.class != String) && (item2.class != String) then
        if (item1 == 0) then
          push_stack(item2)
          push_stack(item1)
          ERROR_ZERO_DEVIDE
        else
          answer = item2 % item1
          push_stack(answer)
          DONE
        end
      else
        push_stack(item2)
        push_stack(item1)
        ERROR_WRONG_ITEM
      end
    else
      ERROR_STACK_NOT_ENOUGH
    end
  end

  def do_rand
    if (stack_size > 0) then
      item1 = pop_stack
      if (item1.class != String) then
        answer = rand(item1.to_i)
        push_stack(answer)
        DONE
      else
        push_stack(item1)
        ERROR_WRONG_ITEM
      end
    else
      ERROR_STACK_NOT_ENOUGH
    end
  end

  def do_true
    push_stack("true")
    DONE
  end

  def do_false
    push_stack("false")
    DONE
  end

  def do_equal
    if (stack_size >= 2) then
      item1 = pop_stack
      item2 = pop_stack
      if (item1.class != String) && (item2.class != String) then
        if (item1 == item2) then
          push_stack("true")
        else
          push_stack("false")
        end
        DONE
      else
        push_stack(item2)
        push_stack(item1)
        ERROR_WRONG_ITEM
      end
    else
      ERROR_STACK_NOT_ENOUGH
    end
  end

  def do_not_equal
    if (stack_size >= 2) then
      item1 = pop_stack
      item2 = pop_stack
      if (item1.class != String) && (item2.class != String) then
        if (item1 != item2) then
          push_stack("true")
        else
          push_stack("false")
        end
        DONE
      else
        push_stack(item2)
        push_stack(item1)
        ERROR_WRONG_ITEM
      end
    else
      ERROR_STACK_NOT_ENOUGH
    end
  end

  def do_less
    if (stack_size >= 2) then
      item1 = pop_stack
      item2 = pop_stack
      if (item1.class != String) && (item2.class != String) then
        if (item1 > item2) then
          push_stack("true")
        else
          push_stack("false")
        end
        DONE
      else
        push_stack(item2)
        push_stack(item1)
        ERROR_WRONG_ITEM
      end
    else
      ERROR_STACK_NOT_ENOUGH
    end
  end

  def do_great 
    if (stack_size >= 2) then
      item1 = pop_stack
      item2 = pop_stack
      if (item1.class != String) && (item2.class != String) then
        if (item1 < item2) then
          push_stack("true")
        else
          push_stack("false")
        end
        DONE
      else
        push_stack(item2)
        push_stack(item1)
        ERROR_WRONG_ITEM
      end
    else
      ERROR_STACK_NOT_ENOUGH
    end
  end

  def do_if
    if (stack_size > 0) then
      item = pop_stack
      push_stack(item)
      if (item == "true") || (item == "false") ||
         (item.class != String) || (@if_nest_count > 0) then
        push_stack("if")
        @if_nest_count += 1
        DONE
      else
        ERROR_WRONG_ITEM
      end
    else
      ERROR_STACK_EMPTY
    end
  end

  def do_else
    if (@if_nest_count > 0) then
      push_stack("else")
      DONE
    else
      ERROR_NET_MATCH_NEST
    end
  end

  def do_endif
    if (@if_nest_count > 0) then
      @if_nest_count -= 1
      # if 1ʬȴФ
      cmd = StackLangLv0::new
      while (stack_size > 0) do
        item = nil
        item = pop_stack
        cmd.push_stack(item)
        if item == "if" then
          break
        end
      end
      cmd.pop_stack
      item = pop_stack
      # if ʬοȽ
      check = false
      if (item.class == String) then
        if (item == "true") then
          check = true
        end
      else
        if (item > 0) then
          check = true
        end
      end
      # ʬ¹
      if (check == true) then
        # true
        while (cmd.stack_size > 0) do
          item = cmd.pop_stack
          if (item.class == String) then
            if (item == "else") then
              break
            end
          end
	  exec_word(item.to_s)
        end
      else
        # false
        flag = false
        while (cmd.stack_size > 0) do
          item = cmd.pop_stack
          if (item.class == String) then
            if (item == "else") then
              flag = true
              next
            end
          end
          if (flag == true) then
            exec_word(item.to_s)
          end
        end
      end
      DONE
    else
      ERROR_NET_MATCH_NEST
    end
  end


end



#--------------------------------------------
#  Level2 : 桼ɤμ
#--------------------------------------------
class  StackLangLv2 < StackLangLv1

  def initialize
    super
    @user_word = Hash::new
    @path_word = ''
    @path_wordlist = ''
  end

  def load_user_word_list(path)
    @path_word = path + "user_word.txt"
    @path_wordlist = path + "user_word_index.txt"
  end

  def add_user_word(name, command)
  end

  def search_user_word(name)
  end

  def user_word?(name)
  end

  def exec_user_word(name)
  end

  # --- inherit

  def command?(item)
    super
  end

  def command(item)
    super
  end

  def exec_word(item)
    super
  end


end


#--------------------------------------------
#  Level3 : ѿɤμ
#--------------------------------------------
class  StackLangLv3 < StackLangLv2

  def initialize
    super
    @variable = Hash::new
  end

  def make_new_variable(name)
  end

  def get_variable(name)
  end

  def put_variable(name, item)
  end

  def variable_word?(name)
  end

  def pack_valiable
  end

  def unpack_valiable(line)
  end

  # --- inherit

  def command?(item)
    super
  end

  def command(item)
    super
  end

  def exec_word(item)
    super
  end

end
